#
# Conditional build:
%bcond_without	eglstream	# XWayland eglstream support
%bcond_without	glamor		# glamor dix module
%bcond_with	xcsecurity	# XC-SECURITY extension (deprecated)
%bcond_with	xf86bigfont	# XF86BigFont extension
%bcond_without	xselinux	# XSELINUX extension
%bcond_without	libunwind	# libunwind for backtracing
%bcond_with	systemtap	# systemtap/dtrace probes
%bcond_without	doc		# don't build documentation

Summary:	Xwayland - X server integrated into a Wayland window system
Summary(pl.UTF-8):	Xwayland - serwer X integrowalny w Wayland
Name:		xorg-xserver-Xwayland
Version:	22.1.7
Release:	1
License:	MIT
Group:		X11/Servers
Source0:	https://xorg.freedesktop.org/releases/individual/xserver/xwayland-%{version}.tar.xz
# Source0-md5:	a814892a54e15d17eb096b8c3dd88b5d
URL:		https://xorg.freedesktop.org/
BuildRequires:	Mesa-dri-devel
%{?with_glamor:BuildRequires:	Mesa-libgbm-devel >= 10.2}
BuildRequires:	OpenGL-devel >= 1.2
%{?with_xselinux:BuildRequires:	audit-libs-devel}
BuildRequires:	docbook-dtd43-xml
%{?with_eglstream:BuildRequires:	egl-wayland-devel}
BuildRequires:	libbsd-devel
BuildRequires:	libdrm-devel >= 2.4.89
%{?with_glamor:BuildRequires:	libepoxy-devel}
# also possible: libmd, libsha, nettle, openssl
BuildRequires:	libgcrypt-devel
%{?with_xselinux:BuildRequires:	libselinux-devel >= 2.0.86}
BuildRequires:	libtirpc-devel
%{?with_libunwind:BuildRequires:	libunwind-devel}
BuildRequires:	meson >= 0.47.0
BuildRequires:	ninja >= 1.5
BuildRequires:	pixman-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.736
%{?with_systemtap:BuildRequires:	systemtap-sdt-devel}
BuildRequires:	tar >= 1:1.22
# wayland-client
BuildRequires:	wayland-devel >= 1.18.0
BuildRequires:	wayland-protocols >= 1.22
%{?with_doc:BuildRequires:	xmlto}
BuildRequires:	xorg-lib-libXau-devel
BuildRequires:	xorg-lib-libXdmcp-devel
BuildRequires:	xorg-lib-libXext-devel >= 1.0.99.4
BuildRequires:	xorg-lib-libXfont2-devel >= 2.0
BuildRequires:	xorg-lib-libxcvt-devel
BuildRequires:	xorg-lib-libxkbfile-devel
BuildRequires:	xorg-lib-libxshmfence-devel >= 1.1
BuildRequires:	xorg-lib-xtrans-devel >= 1.3.5
BuildRequires:	xorg-proto-bigreqsproto-devel >= 1.1.0
BuildRequires:	xorg-proto-compositeproto-devel >= 0.4
BuildRequires:	xorg-proto-damageproto-devel >= 1.1
BuildRequires:	xorg-proto-dri3proto-devel >= 1.2
BuildRequires:	xorg-proto-fixesproto-devel >= 6.0
BuildRequires:	xorg-proto-fontsproto-devel >= 2.1.3
BuildRequires:	xorg-proto-glproto-devel >= 1.4.17
BuildRequires:	xorg-proto-inputproto-devel >= 2.3
BuildRequires:	xorg-proto-kbproto-devel >= 1.0.3
BuildRequires:	xorg-proto-presentproto-devel >= 1.2
BuildRequires:	xorg-proto-randrproto-devel >= 1.6.0
BuildRequires:	xorg-proto-recordproto-devel >= 1.13.99.1
BuildRequires:	xorg-proto-renderproto-devel >= 0.11
BuildRequires:	xorg-proto-resourceproto-devel >= 1.2.0
BuildRequires:	xorg-proto-scrnsaverproto-devel >= 1.1
BuildRequires:	xorg-proto-videoproto-devel
BuildRequires:	xorg-proto-xcmiscproto-devel >= 1.2.0
BuildRequires:	xorg-proto-xextproto-devel >= 7.2.99.901
%{?with_xf86bigfont:BuildRequires:	xorg-proto-xf86bigfontproto-devel >= 1.2.0}
BuildRequires:	xorg-proto-xf86vidmodeproto-devel >= 2.2.99.1
BuildRequires:	xorg-proto-xineramaproto-devel
BuildRequires:	xorg-proto-xproto-devel >= 7.0.31
%{?with_doc:BuildRequires:	xorg-sgml-doctools}
BuildRequires:	xz
%{?with_glamor:Requires:	Mesa-libgbm >= 10.2}
Requires:	libdrm >= 2.4.89
%{?with_xselinux:Requires:	libselinux >= 2.0.86}
Requires:	wayland >= 1.18.0
Requires:	xorg-app-xkbcomp
Requires:	xorg-lib-libXext >= 1.0.99.4
Requires:	xorg-lib-libXfont2 >= 2.0
Requires:	xorg-lib-libxshmfence >= 1.1
# for protocol.txt
Requires:	xorg-xserver-common >= 1.20
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Xwayland - server integrated into a Wayland window system.

%description -l pl.UTF-8
Xwayland - serwer X integrowalny w Wayland.

%package devel
Summary:	Development file for Xwayland server
Summary(pl.UTF-8):	Plik programistyczny serwera Xwayland
Group:		Development/Libraries

%description devel
Development file for Xwayland server, containing server build
configuration.

%description devel -l pl.UTF-8
Plik programistyczny serwera Xwayland, zawierający konfigurację
zbudowanego serwera.

%prep
%setup -q -n xwayland-%{version}

%build
%meson build \
	-Dbuilder_addr="feedback@pld-linux.org" \
	-Dbuilder_string="%{name}-%{version}-%{release}" \
	-Ddefault_font_path="%{_fontsdir}/misc,%{_fontsdir}/TTF,%{_fontsdir}/OTF,%{_fontsdir}/Type1,%{_fontsdir}/100dpi,%{_fontsdir}/75dpi" \
	-Ddevel-docs=%{__true_false doc} \
	-Ddocs=%{__true_false doc} \
	-Ddocs-pdf=false \
	%{?with_systemtap:-Ddtrace=true} \
	%{!?with_glamor:-Dglamor=false} \
	%{?with_libunwind:-Dlibunwind=true} \
	-Dsha1=libgcrypt \
	-Dvendor_name="PLD Linux" \
	%{?with_xcsecurity:-Dxcsecurity=true} \
	%{?with_xf86bigfont:-Dxf86bigfont=true} \
	-Dxkb_bin_dir=%{_bindir} \
	-Dxkb_dir=%{_datadir}/X11/xkb \
	-Dxkb_output_dir=/var/lib/xkb \
	%{!?with_xselinux:-Dxselinux=false} \
	%{!?with_eglstream:-Dxwayland_eglstream=false}

%ninja_build -C build

%install
rm -rf $RPM_BUILD_ROOT

%ninja_install -C build

# xorg-xserver-common package (common dependency for Xwayland and Xorg)
%{__rm} $RPM_BUILD_ROOT%{_libdir}/xorg/protocol.txt
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man1/Xserver.1

%{?with_doc:%{__rm} $RPM_BUILD_ROOT%{_docdir}/xorg-server/Xserver-DTrace.*}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc COPYING README.md
%attr(755,root,root) %{_bindir}/Xwayland
%{_mandir}/man1/Xwayland.1*

%files devel
%defattr(644,root,root,755)
%{?with_doc:%doc build/doc/{Xinput,Xserver-spec}.html build/doc/dtrace/Xserver-DTrace.html}
%{_pkgconfigdir}/xwayland.pc
%changelog
* Tue Dec 20 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xorg-xserver-Xwayland.git;a=log;h=master

* Tue Dec 20 2022 Jan Palus <atler@pld-linux.org> 91a2a38
- up to 22.1.7

* Wed Dec 14 2022 Jan Palus <atler@pld-linux.org> f9cc248
- BR: pkgconfig

* Wed Dec 14 2022 Jan Palus <atler@pld-linux.org> 2cceab7
- up to 22.1.6

* Wed Nov 02 2022 Jan Palus <atler@pld-linux.org> b189ef2
- up to 22.1.5

* Tue Oct 25 2022 Jan Palus <atler@pld-linux.org> 8013402
- up to 22.1.4

* Tue Jul 12 2022 Jan Palus <atler@pld-linux.org> 5ed1c89
- missing BR: xmlto for docs and doc bcond

* Tue Jul 12 2022 Jakub Bogusz <qboosh@pld-linux.org> edb7330
- updated to 22.1.3

* Thu May 26 2022 Jan Palus <atler@pld-linux.org> e4ae878
- up to 22.1.2

* Thu May 26 2022 Jan Palus <atler@pld-linux.org> c1a6773
- BR: docbook-dtd43-xml xorg-sgml-doctools for docs

* Thu Mar 31 2022 Jakub Bogusz <qboosh@pld-linux.org> b963014
- updated to 22.1.1

* Tue Feb 22 2022 Jakub Bogusz <qboosh@pld-linux.org> 4a66d36
- docs packaging update

* Tue Feb 22 2022 Jan Palus <atler@pld-linux.org> 587212b
- up to 22.1.0

* Mon Dec 27 2021 Jan Palus <atler@pld-linux.org> eea9e69
- updated deps

* Tue Dec 14 2021 Jakub Bogusz <qboosh@pld-linux.org> af4c2c6
- updated to 21.1.4

* Mon Nov 08 2021 Jakub Bogusz <qboosh@pld-linux.org> bb62ac1
- updated to 21.1.3

* Fri Jul 09 2021 Jan Palus <atler@pld-linux.org> 7c0c4ff
- up to 21.1.2

* Sat May 15 2021 Jakub Bogusz <qboosh@pld-linux.org> 8b1103e
- separated .pc file to -devel (for building e.g. mutter); release 1

* Wed May 12 2021 Jakub Bogusz <qboosh@pld-linux.org> 67cd203
- require xorg-xserver-common

* Tue Apr 13 2021 Jan Palus <atler@pld-linux.org> c187d2d
- macros for %ninja*

* Tue Apr 13 2021 Jan Palus <atler@pld-linux.org> 99969bc
- up to 21.1.1 (fixes CVE-2021-3472)

